clear all
close all

a=0.0;
b=2*pi;
c2=0.0;
d=2*pi;

%nplus1=10;
nplus1=40;
%nplus1=20;
%nplus1=80;
n=nplus1-1;
diffcoe=0.2;
h=(b-a)/(n+1);
c=diffcoe/h/h;    

X=zeros(n*(n+1),1);
Y=zeros(n*(n+1),1);
U=zeros(n*(n+1),1);
TermK=zeros(n*(n+1),1);
U2=zeros(n*(n+1),1);

for i=1:n
    for j=1:nplus1
        X((i-1)*nplus1+j)=i*h; 
    end 
end

for i=1:n
    for j=1:nplus1
        Y((i-1)*nplus1+j)=j*h;
    end 
end

U=init(X,Y);
DA=zeros(n*(n+1),n*(n+1));

DA1=eye(n+1);
DA2=2.0/3.0*eye(n+1);
DA3=-8.0/3.0*eye(n+1);
DA4=-4.0*eye(n+1);
DA3(1,n+1)=1.0;
DA3(n+1,1)=1.0;
DA4(1,n+1)=1.0;
DA4(n+1,1)=1.0;
for k=1:n
    DA3(k,k+1)=1.0;
    DA3(k+1,k)=1.0;
    DA4(k,k+1)=1.0;
    DA4(k+1,k)=1.0;
end

DA(1:nplus1,1:nplus1)=DA3;
DA(1:nplus1,n+2:2*(n+1))=DA2;
DA((n-1)*nplus1+1:n*nplus1,(n-2)*nplus1+1:(n-1)*nplus1)=DA2;
DA((n-1)*nplus1+1:n*nplus1,(n-1)*nplus1+1:n*nplus1)=DA3;
for k=2:n-1
    DA((k-1)*nplus1+1:k*nplus1,(k-2)*nplus1+1:(k-1)*nplus1)=DA1;
    DA((k-1)*nplus1+1:k*nplus1,(k-1)*nplus1+1:k*nplus1)=DA4;
    DA((k-1)*nplus1+1:k*nplus1,k*nplus1+1:(k+1)*nplus1)=DA1;
end

DA=c*DA;


ttt4=cputime;

dt=0.5*h;
EA=expm(dt*DA);

tend=1.0;
tnum=0.0;
istop=0;

while istop==0
    if(tnum+dt > tend)
        dt=tend-tnum;
        EA=expm(dt*DA);
        istop=1;
    end
    
    TermK=EA*(U+(dt/2.0)*f(U));
    
    U2=TermK+(dt/2.0)*f(U);
    
    while max(max(U2-U))>0
        U=U2;
        U2=TermK+(dt/2.0)*f(U);
    end
    U=U2;
    
    tnum=tnum+dt;
end

format long
cpu_time = cputime-ttt4

Uexact=exact(X, Y, tend);


format long
error=max(max(U-Uexact))

            
    
    
